unit MyPlugin;

interface

uses
   Windows,
   Messages,
   SysUtils,
   Classes,
   VCL.Dialogs,
   VCL.Forms,
   PluginCore;

type

TAPlugin = class(TF8PLuginClass)
    private
      { Private declarations }
      p_winRoadApplication : IF8ApplicationServices;

    public
      { Public declarations }

      procedure AfterConstruction; override;
      procedure BeforeDestruction; override;

      property winRoadApplication : IF8ApplicationServices read p_winRoadApplication;
    end;


//Call back functions
procedure RegisterUserPlugin(out optionName, apiVersion : String);
procedure LoadPlugin;
procedure UnloadPlugin;

var

    APlugin : TAPlugin;


implementation


//==============================================================================
//   Registers the plugin
//==============================================================================
procedure RegisterUserPlugin(out optionName, apiVersion : String);
    begin
    optionName := 'My Plugin';
    apiVersion := PLUGIN_VERSION;
    end;

procedure LoadPlugin;
    begin
    if not Assigned(APlugin) then
        APlugin := TAPlugin.Create;
    end;

procedure UnloadPlugin;
    begin
    // Free the plugin
    APlugin.Free;
    end;


{ TAPlugin }

//==============================================================================
//  On plugin creation :
//     Gets the interface of the application.
//==============================================================================
procedure TAPlugin.AfterConstruction;
    begin
    Supports(ApplicationServices, IF8ApplicationServices, p_winRoadApplication);
    end;

//==============================================================================
//  On plugin destruction :
//     Releases the interface of the application.
//==============================================================================
procedure TAPlugin.BeforeDestruction;
    begin
    p_winRoadApplication := nil;
    end;

end.
