# coding: UTF-8

import Tkinter as tk
import pygame
from pygame.locals import *

class EyeBox():

    def __init__(self, id, x, y, width, height, borderColor, fillColor):
        self.id = id
        self.x = x
        self.y = y
        self.width = width
        self.height = height
        self.borderColor = borderColor
        self.fillColor = fillColor

    def paint(self, surface, sysfont, focus_box):
        if self.id == focus_box:
            borderColor = self.borderColor
            fillColor = (255, 0, 0)
        else:
            borderColor = self.borderColor
            fillColor = self.fillColor

        pygame.draw.rect(surface, fillColor, pygame.Rect(self.x, self.y, self.width, self.height))
        pygame.draw.rect(surface, borderColor, pygame.Rect(self.x, self.y, self.width, self.height), 2)
        text = sysfont.render(str(self.id), True, borderColor)
        surface.blit(text, (self.x + self.width / 2, self.y + self.height / 2))

    def contain(self, x, y):
        if(self.x <= x and x <= (self.x + self.width) and self.y <= y and y <= (self.y + self.height)):
            return True
        else:
            return False
