import time
import tobii_research as tr

def findEyeTrackers():

    eyetrackers = tr.find_all_eyetrackers()

    for eyetracker in eyetrackers:
        '''
        print "Address: " + eyetracker.address
        print "Model: " + eyetracker.model
        print "Name (It's OK if this is empty): " + eyetracker.device_name
        print "Serial number: " + eyetracker.serial_number

        if tr.CAPABILITY_CAN_SET_DISPLAY_AREA in eyetracker.device_capabilities:
            print "The display area can be set on the eye tracker."
        else:
            print "The display area can not be set on the eye tracker."

        if tr.CAPABILITY_HAS_EXTERNAL_SIGNAL in eyetracker.device_capabilities:
            print "The eye tracker can deliver an external signal stream."
        else:
            print "The eye tracker can not deliver an external signal stream."

        if tr.CAPABILITY_HAS_EYE_IMAGES in eyetracker.device_capabilities:
            print "The eye tracker can deliver an eye image stream."
        else:
            print "The eye tracker can not deliver an eye image stream."

        if tr.CAPABILITY_HAS_GAZE_DATA in eyetracker.device_capabilities:
            print "The eye tracker can deliver a gaze data stream."
        else:
            print "The eye tracker can not deliver a gaze data stream."

        if tr.CAPABILITY_HAS_HMD_GAZE_DATA in eyetracker.device_capabilities:
            print "The eye tracker can deliver a HMD gaze data stream."
        else:
            print "The eye tracker can not deliver a HMD gaze data stream."

        if tr.CAPABILITY_CAN_DO_SCREEN_BASED_CALIBRATION in eyetracker.device_capabilities:
            print "The eye tracker can do a screen based calibration."
        else:
            print "The eye tracker can not do a screen based calibration."

        if tr.CAPABILITY_CAN_DO_HMD_BASED_CALIBRATION in eyetracker.device_capabilities:
            print "The eye tracker can do a HMD screen based calibration."
        else:
            print "The eye tracker can not do a HMD screen based calibration."

        if tr.CAPABILITY_HAS_HMD_LENS_CONFIG in eyetracker.device_capabilities:
            print "The eye tracker can get/set the HMD lens configuration."
        else:
            print "The eye tracker can not get/set the HMD lens configuration."
        '''

    return eyetrackers


def applyLicense(eyetracker, license_file_path):

    #print "[APPLYING LICENSE]"
    #print "[APPLYING LICENSE FROM {0}]".format(license_file_path)
    with open(license_file_path, "rb") as f:
        license = f.read()

    failed_licenses_applied_as_list_of_keys = eyetracker.apply_licenses([tr.LicenseKey(license)])
    failed_licenses_applied_as_list_of_bytes = eyetracker.apply_licenses([license])
    failed_licenses_applied_as_key = eyetracker.apply_licenses(tr.LicenseKey(license))
    failed_licenses_applied_as_bytes = eyetracker.apply_licenses(license)

    '''
    if len(failed_licenses_applied_as_list_of_keys) == 0:
        print "Successfully applied license from list of keys."
    else:
        print "Failed to apply license from list of keys. Validation result: {0}.".format(failed_licenses_applied_as_list_of_keys[0].validation_result)

    if len(failed_licenses_applied_as_list_of_bytes) == 0:
        print "Successfully applied license from list of bytes."
    else:
        print "Failed to apply license from list of bytes. Validation result: {0}.".format(failed_licenses_applied_as_list_of_bytes[0].validation_result)

    if len(failed_licenses_applied_as_key) == 0:
        print "Successfully applied license from single key."
    else:
        print "Failed to apply license from single key. Validation result: {0}.".format(failed_licenses_applied_as_key[0].validation_result)

    if len(failed_licenses_applied_as_bytes) == 0:
        print "Successfully applied license from bytes object."
    else:
        print "Failed to apply license from bytes object. Validation result: {0}.".format(failed_licenses_applied_as_bytes[0].validation_result)
    '''

# Start EyeTracking
def startEyeTracking(eyetracker, callback):
    #print "Subscribing to gaze data for eye tracker with serial number {0}.".format(eyetracker.serial_number)
    #print "[START EYETRACKING]"
    eyetracker.subscribe_to(tr.EYETRACKER_GAZE_DATA, callback, as_dictionary=False)

# Stop EyeTracking
def stopEyeTracking(eyetracker, callback):
    #print "[STOP EYETRACKING]"
    #print "Unsubscribed from gaze data."
    eyetracker.unsubscribe_from(tr.EYETRACKER_GAZE_DATA, callback)
