# coding: UTF-8

import socket
import Tkinter as tk
from SimData import SimData

# メッセージ長
MESSAGE_LENGTH = 4096

# サーバー・アドレス
S_ADDR = "127.0.0.1"

# サーバー・ポート
S_PORT = 54321

# 初期座標
INIT_X = 6604.0
INIT_Y = 3547.0

# 初期方向
INIT_DX = 1.0
INIT_DY = 0.0

# 初期ハンドル角
INIT_HANDLE = 0.0

# 初期アクセル
INIT_ACCEL = 0.0

# 初期ブレーキ
INIT_BRAKE = 0.0

# 初期速度
INIT_SPEED = 0.0

# 初期データ
simdata = SimData(INIT_X, INIT_Y, INIT_DX, INIT_DY, INIT_HANDLE, INIT_ACCEL, INIT_BRAKE, INIT_SPEED)

def send():

    # IPV4(AF_INET), TCP/IP(SOCK_DGRAM)でソケット作成
    client = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

    # メッセージの作成
    simdata = SimData(x_entry.get(), y_entry.get(), dx_entry.get(), dy_entry.get(), handle_entry.get(), accel_entry.get(), brake_entry.get(), speed_entry.get())
    message = simdata.toMessage()
    print(simdata.toString())

    # サーバーにメッセージ送信
    client.sendto(message, (ip_entry.get(), int(port_entry.get())))

# ウィンドウの作成
window = tk.Tk()
window.title("NaviRoboClient")
window.geometry("320x280")

# IPアドレス．フレームの作成
ip_frame = tk.Frame(window)
ip_frame.pack()

# IPアドレス・ラベルの作成
ip_label = tk.Label(ip_frame, text="IP:", font=20, width=6)
ip_label.pack(side="left")

# IPアドレス・フィールドの作成
ip_entry = tk.Entry(ip_frame, font=20, width=25)
ip_entry.insert(0, S_ADDR)
ip_entry.pack(side="left")

# ポート．フレームの作成
port_frame = tk.Frame(window)
port_frame.pack()

# ポート・ラベルの作成
port_label = tk.Label(port_frame, text="PT:", font=20, width=6)
port_label.pack(side="left")

# ポート・フィールドの作成
port_entry = tk.Entry(port_frame, font=20, width=25)
port_entry.insert(0, S_PORT)
port_entry.pack(side="left")

# X座標・フレームの作成
x_frame = tk.Frame(window)
x_frame.pack()

# X座標・ラベルの作成
x_label = tk.Label(x_frame, text="X:", font=20, width=6)
x_label.pack(side="left")

# X座標・フィールドの作成
x_entry = tk.Entry(x_frame, font=20, width=25)
x_entry.insert(0, simdata.x)
x_entry.pack(side="left")

# Y座標・フレームの作成
y_frame = tk.Frame(window)
y_frame.pack()

# X座標・ラベルの作成
y_label = tk.Label(y_frame, text="Y:", font=20, width=6)
y_label.pack(side="left")

# X座標・フィールドの作成
y_entry = tk.Entry(y_frame, font=20, width=25)
y_entry.insert(0, simdata.y)
y_entry.pack(side="left")

# X方向・フレームの作成
dx_frame = tk.Frame(window)
dx_frame.pack()

# X方向・ラベルの作成
dx_label = tk.Label(dx_frame, text="DX:", font=20, width=6)
dx_label.pack(side="left")

# X方向・フィールドの作成
dx_entry = tk.Entry(dx_frame, font=20, width=25)
dx_entry.insert(0, simdata.dx)
dx_entry.pack(side="left")

# Y方向・フレームの作成
dy_frame = tk.Frame(window)
dy_frame.pack()

# Y方向・ラベルの作成
dy_label = tk.Label(dy_frame, text="DY:", font=20, width=6)
dy_label.pack(side="left")

# Y方向・フィールドの作成
dy_entry = tk.Entry(dy_frame, font=20, width=25)
dy_entry.insert(0, simdata.dy)
dy_entry.pack(side="left")

# ハンドル角・フレームの作成
handle_frame = tk.Frame(window)
handle_frame.pack()

# ハンドル角・ラベルの作成
handle_label = tk.Label(handle_frame, text="HDL:", font=20, width=6)
handle_label.pack(side="left")

# ハンドル角・フィールドの作成
handle_entry = tk.Entry(handle_frame, font=20, width=25)
handle_entry.insert(0, simdata.handle)
handle_entry.pack(side="left")

# アクセル・フレームの作成
accel_frame = tk.Frame(window)
accel_frame.pack()

# アクセル・ラベルの作成
accel_label = tk.Label(accel_frame, text="ACL:", font=20, width=6)
accel_label.pack(side="left")

# アクセル・フィールドの作成
accel_entry = tk.Entry(accel_frame, font=20, width=25)
accel_entry.insert(0, simdata.accel)
accel_entry.pack(side="left")

# ブレーキ・フレームの作成
brake_frame = tk.Frame(window)
brake_frame.pack()

# ブレーキ・ラベルの作成
brake_label = tk.Label(brake_frame, text="BRK:", font=20, width=6)
brake_label.pack(side="left")

# ブレーキ・フィールドの作成
brake_entry = tk.Entry(brake_frame, font=20, width=25)
brake_entry.insert(0, simdata.brake)
brake_entry.pack(side="left")

# 速度・フレームの作成
speed_frame = tk.Frame(window)
speed_frame.pack()

# 速度・ラベルの作成
speed_label = tk.Label(speed_frame, text="SPD:", font=20, width=6)
speed_label.pack(side="left")

# 速度・フィールドの作成
speed_entry = tk.Entry(speed_frame, font=20, width=25)
speed_entry.insert(0, simdata.speed)
speed_entry.pack(side="left")

# ボタン・フレームの作成
bt_frame = tk.Frame(window)
bt_frame.pack(pady=10);

# 送信ボタンの作成
send_bt = tk.Button(bt_frame, text="SEND", height=1, command=lambda:send(), width=15)
send_bt.pack(side="left")

window.mainloop()
