# coding: UTF-8

import Tkinter as tk
import pygame
from pygame.locals import *
import sys
import subprocess
import EyeTrackModule as em
from EyeBox import EyeBox
from SocketThread import SocketThread

# コンソールの文字コード設定
subprocess.call("chcp.com 65001")

# ウィンドウの設定
NO_WINDOW = 0
ICON_WINDOW = 1
FULL_WINDOW = 2
FULL_SCREEN = 3
SCREEN_SETTING = FULL_WINDOW
# メッセージ長
MESSAGE_LENGTH = 4096

# サーバー・アドレス
S_ADDR = "127.0.0.1"

# サーバー・ポート
S_PORT = 54321

# サーバー・タイムアウト
S_TIMEOUT = 3.0

# スクリーン・サイズ
SCREEN_WIDTH = 1920
SCREEN_HEIGHT = 1080

# アイトラッカーのライセンス
LICENSE_FILE = "license/license_key_00414084_-_SJU_IS404-100107812654"

# フォーカス座標
focus_x = 0
focus_y = 0
focus_box = -1

# EyeTrackerの取得
eyetrackers = em.findEyeTrackers()
if len(eyetrackers) >= 1:
    eyetracker = eyetrackers[0]
else:
    print "[Error: Not Found EyeTracker]"
    sys.exit()

# スレッドの作成
thread = SocketThread(S_ADDR, S_PORT, S_TIMEOUT, MESSAGE_LENGTH)
thread.start();

# スレッドの開始
def startThread():
    global thread
    thread = SocketThread(S_ADDR, S_PORT, S_TIMEOUT, MESSAGE_LENGTH)
    thread.start()

# スレッドの停止
def stopThread():
    global thread
    thread.stop()

# アイトラッカーのコールバック関数
def callback(gaze_data):
    global focus_x
    global focus_y
    global boxes
    time_stamp = gaze_data.device_time_stamp
    left_point = gaze_data.left_eye.gaze_point.position_on_display_area
    right_point = gaze_data.right_eye.gaze_point.position_on_display_area
    left_x = left_point[0] * SCREEN_WIDTH
    left_y = left_point[1] * SCREEN_HEIGHT
    right_x = right_point[0] * SCREEN_WIDTH
    right_y = right_point[1] * SCREEN_HEIGHT
    focus_x = int((left_x + right_x) / 2)
    focus_y = int((left_y + right_y) / 2)

# アイトラッキングの開始
def startEyeTracking():
    em.startEyeTracking(eyetracker, callback)

# アイトラッキングの停止
def stopEyeTracking():
    em.stopEyeTracking(eyetracker, callback)

startEyeTracking()

# ウィンドウを終了
def closeWindow():
    stopThread()
    stopEyeTracking()
    pygame.quit()
    sys.exit()

# 9分割のボックスの作成
boxes = []
unit_x = int(SCREEN_WIDTH / 3)
unit_y = int(SCREEN_HEIGHT / 3)
for i in range(3):
    for j in range(3):
        id = (3 * i) + j
        x = unit_x * j
        y = unit_y * i
        eb = EyeBox(id, x, y, unit_x, unit_y, (0, 0, 0), (255, 255, 0))
        boxes.append(eb)

# EyeTrackerのライセンス
em.applyLicense(eyetracker, LICENSE_FILE)

# ウィンドウの生成
if(SCREEN_SETTING != NO_WINDOW):

    # PYGAMEの初期化
    pygame.init();

    # ウィンドウの表示
    if(SCREEN_SETTING == ICON_WINDOW):
        surface = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
        pygame.display.iconify()
    elif(SCREEN_SETTING == FULL_WINDOW):
        surface = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT))
    elif(SCREEN_SETTING == FULL_SCREEN):
        surface = pygame.display.set_mode((SCREEN_WIDTH, SCREEN_HEIGHT), pygame.FULLSCREEN)

    sysfont = pygame.font.SysFont(None, 80)
    pygame.display.set_caption("NaviRoboEye")

    while(True):

        surface.fill((255, 255, 255))

        focus_box = -1
        for i in range(len(boxes)):
            if(boxes[i].contain(focus_x, focus_y)):
                focus_box = i

        for i in range(len(boxes)):
            boxes[i].paint(surface, sysfont, focus_box)
            thread.setFocus(focus_box, focus_x, focus_y)

        for event in pygame.event.get():
            # ウィンドウの☓ボタンで終了
            if event.type == QUIT:
                closeWindow()
            # キーイベント
            if event.type == KEYDOWN:
                if event.key == K_RETURN:
                    if thread.is_alive():
                        stopThread()
                    else:
                        startThread()
                if event.key == K_ESCAPE:
                    closeWindow()

        pygame.display.update()

# スレッド終了を待機
thread.join()
closeWindow()
