# coding: UTF-8

import time;

class SimData():

    def __init__(self, x=0, y=0, dx=0, dy=0, handle=0, accel=0, brake=0, speed=0):
        self.x = x
        self.y = y
        self.dx = dx
        self.dy = dy
        self.handle = handle
        self.accel = accel
        self.brake = brake
        self.speed = speed
        self.comment = "SimData"
        self.focus = -1
        self.focus_x = -1
        self.focus_y = -1

    def set(self, message, focus, focus_x, focus_y):
        tokens = message.split(",")
        self.x = float(tokens[0])
        self.y = float(tokens[1])
        self.dx = float(tokens[2])
        self.dy = float(tokens[3])
        self.handle = float(tokens[4])
        self.accel = float(tokens[5])
        self.brake = float(tokens[6])
        self.speed = float(tokens[7])
        self.comment = tokens[8]
        self.focus = int(focus)
        self.focus_x = float(focus_x)
        self.focus_y = float(focus_y)

    def toString(self):
        text = "[X=" + str(self.x) + " Y=" + str(self.y) + " DX=" + str(self.dx) + " DY=" + str(self.dy) + " HDL=" + str(self.handle) + " ACL=" + str(self.accel) + " BRK=" + str(self.brake) + " SPD=" + str(self.speed) + " COM=" + self.comment + " FOC=" + str(self.focus) + " FOCX=" + str(self.focus_x) + " FOCY=" + str(self.focus_y) + "]"
        return text

    def toMessage(self):        
        message = self.x + "," + self.y + "," + self.dx + "," + self.dy + "," + self.handle + "," + self.accel + "," + self.brake + "," + self.speed + "," + self.comment
        return message

    def setFocus(self, focus):
        self.focus = focus

    def toCSV(self):
        csv = []
        csv.append(time.time())
        csv.append(self.x)
        csv.append(self.y)
        csv.append(self.dx)
        csv.append(self.dy)
        csv.append(self.handle)
        csv.append(self.accel)
        csv.append(self.brake)
        csv.append(self.speed)
        csv.append(self.focus)
        csv.append(self.focus_x)
        csv.append(self.focus_y)
        csv.append(self.comment)
        return csv
